<script setup lang="ts">
import { computed } from "vue";

const props = defineProps<{
  currentVal: number;
  maximum: number;
  label?: string;
}>();

const percentage = computed<number>(
  () => (100 * props.currentVal) / props.maximum,
);

const cssWidth = computed<number>(() =>
  Math.min(100, Math.round(percentage.value)),
);

const colorClass = computed(() => {
  if (percentage.value > 90) {
    return "text-bg-danger";
  } else if (percentage.value > 75) {
    return "text-bg-warning";
  }
  return "text-bg-success text-dark";
});
</script>

<template>
  <div
    class="progress"
    role="progressbar"
    aria-label="Warning example"
    :aria-valuenow="cssWidth"
    aria-valuemin="0"
    aria-valuemax="100"
  >
    <div
      class="progress-bar overflow-visible"
      :class="colorClass"
      :style="{ width: cssWidth + '%' }"
    >
      <template v-if="label">{{ label }}</template>
      <template v-else> {{ percentage.toFixed(2) }}% </template>
    </div>
  </div>
</template>

<style scoped></style>
